#ifndef DEMO_H
#define DEMO_H

#include <QMainWindow>
#include <QGraphicsScene>
#include <QTreeWidgetItem>
#include <QTableWidgetItem>

#include "view.h"
#include "win.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow, public Win
{
    Q_OBJECT

public:
    MainWindow (QWidget * parent = nullptr);
    ~MainWindow ();

    void openFile (QString fileName);
    void saveFile(QString fileName);

    void refreshTree ();
    void refreshProperties (QGraphicsItem * item);
    void refreshTreeName (QGraphicsItem * item, QString name);

private slots:
    void on_actionOpen_triggered ();
    void on_actionSave_triggered ();

    void on_actionRun_triggered ();
    void on_actionQuit_triggered ();

    void on_tree_itemDoubleClicked (QTreeWidgetItem *item, int column);

    void on_actionCopy_triggered();

    void on_actionPaste_triggered();

    void on_tree_itemSelectionChanged();

private:
    Ui::MainWindow * ui;
    // QGraphicsScene * scene;
    Scene * scene;
};

#endif // DEMO_H
